package com.nisum.service;

import com.nisum.dao.Dao;
import com.nisum.dto.impl.EmployeeDto;
import com.nisum.model.impl.EmployeeImp;
import com.nisum.model.impl.JobRoleImp;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;


import java.util.Collection;
import java.util.Optional;

@Service
public class EmployeeService {

  @Autowired
  @Qualifier(value = "EmployeeDao")
  private Dao employeeDao;

  public Collection<EmployeeImp> getAllEmployees() { return employeeDao.getAll(); }


  //create a new employee method
  public void createEmployee(EmployeeDto employeeDto) {
    EmployeeImp newEmployee = new EmployeeImp();
    JobRoleImp newJob = new JobRoleImp(employeeDto.getJobTitle());
    newEmployee.setFirstName(employeeDto.getFirstName());
    newEmployee.setLastName(employeeDto.getLastName());
    newEmployee.setJobRole(newJob);
    //save persists the information on the
    employeeDao.save(newEmployee);
  }




  //create a method to edit existing employee
  public Optional<EmployeeImp> editEmployee(EmployeeDto employeeDto) {
    EmployeeImp employee = employeeDao.findEmployeeById(employeeDto);
    employee.setFirstName(employeeDto.getFirstName());
    employee.setLastName(employeeDto.getLastName());
    employeeDao.update(employee);
    return null;
  }




  //create a method to delete an existing employee


}
